// File: Mystring.cpp

#include "Mystring.h"
using namespace std;

Mystring::Mystring(const char* arg) : string(arg)
{
}

Mystring::Mystring(const Mystring& object) : string(object)
{
}

// unsigned int conversion operator
// algorithm: multiply or add(ascii code - 96) for each char of string
Mystring::operator unsigned() const
{
    size_t i;
    unsigned product = 1;
    for (i = 0; i < size(); i++)
    {
        if (i % 2) product *= (*this)[i] - 96;
        else product += (*this)[i] - 96;
    }
    return product;
}

void Mystring::tolower()
{
    for (size_t i = 0; i < size(); i++)
    {
        this->operator[](i) = ::tolower(this->operator[](i));
    }
}

// Remove non-alpha char before first alpha char and after last alpha char

void Mystring::removePunctuation()
{
   // remove ending 's
   if (this->size() > 2 and this->find("\'s") == (this->size()- 2))
   {
      this->resize(this->size()-2);
   }

    string letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
    size_t start_pos = find_first_of(letters);
    if (start_pos == string::npos)
    {
        assign("");
        return;
    }
    size_t end_pos = this->find_last_of(letters);
    assign(substr(start_pos, end_pos - start_pos + 1));
}
